Loading...
Searching...
No Matches
Sip_rseq

## Data Structures

struct | sip_rseq_s
| Structure for RSeq header. More...

## Macros

#define | sip_rseq(sip)
| Access a SIP RSeq header structure sip_rseq_t from sip_t.
#define | SIP_RSEQ_INIT()
| Initializer for structure sip_rseq_t.
#define | SIPTAG_RSEQ(x)
| Tag list item for pointer to a RSeq header structure sip_rseq_t.
#define | SIPTAG_RSEQ_REF(x)
| Tag list item for reference to a RSeq header pointer.
#define | SIPTAG_RSEQ_STR(s)
| Tag list item for string with RSeq header value.
#define | SIPTAG_RSEQ_STR_REF(x)
| Tag list item for reference to a RSeq header string.

## Typedefs

typedef struct sip_rseq_s | sip_rseq_t
| @

## Functions

issize_t | sip_rseq_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP RSeq header.
issize_t | sip_rseq_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP RSeq header.
sip_rseq_t * | sip_rseq_init (sip_rseq_t x[1])
| Initialize a structure sip_rseq_t.
int | sip_is_rseq (sip_header_t const *header)
| Test if header object is instance of sip_rseq_t.
sip_rseq_t * | sip_rseq_dup (su_home_t *home, sip_rseq_t const *hdr))
| Duplicate a list of RSeq header header structures sip_rseq_t.
sip_rseq_t * | sip_rseq_copy (su_home_t *home, sip_rseq_t const *hdr))
| Copy a list of RSeq header header structures sip_rseq_t.
sip_rseq_t * | sip_rseq_make (su_home_t *home, char const *s))
| Make a RSeq header structure sip_rseq_t.
sip_rseq_t * | sip_rseq_format (su_home_t *home, char const *fmt,...)))
| Make a RSeq header from formatting result.

## Variables

msg_hclass_t | sip_rseq_class []
| Header class for RSeq header.
tag_typedef_t | siptag_rseq
| Tag for RSeq header object.
tag_typedef_t | siptag_rseq_str
| Tag for string with RSeq header value.

## Detailed Description

## Macro Definition Documentation

## SIP_RSEQ_INIT

#define SIP_RSEQ_INIT | ( |  | ) |

Initializer for structure sip_rseq_t.

A static sip_rseq_t structure for RSeq header must be initialized with the SIP_RSEQ_INIT() macro. For instance,

sip_rseq_t sip_rseq = SIP_RSEQ_INIT;
sip_rseq_t
struct sip_rseq_s sip_rseq_t
@
Definition sip.h:188
sip_rseq
#define sip_rseq(sip)
Access a SIP RSeq header structure sip_rseq_t from sip_t.
Definition sip_protos.h:2987
SIP_RSEQ_INIT
#define SIP_RSEQ_INIT()
Initializer for structure sip_rseq_t.
Definition sip_protos.h:3004

## SIPTAG_RSEQ

#define SIPTAG_RSEQ | ( |  | x | ) |

Tag list item for pointer to a RSeq header structure sip_rseq_t.

The SIPTAG_RSEQ() macro is used to include a tag item with a pointer to a sip_rseq_t structure in a tag list.

Parameters

  x | pointer to a sip_rseq_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_RSEQ_REF().

## SIPTAG_RSEQ_STR

#define SIPTAG_RSEQ_STR | ( |  | s | ) |

Tag list item for string with RSeq header value.

The SIPTAG_RSEQ_STR() macro is used to include a tag item with a string containing value of a sip_rseq_t header in a tag list.

Parameters

  s | pointer to a string containing RSeq header value, or NULL.

The string in SIPTAG_RSEQ_STR() can be converted to a sip_rseq_t header structure by giving the string s has second argument to function sip_rseq_make().

The corresponding tag taking reference parameter is SIPTAG_RSEQ_STR_REF().

## Typedef Documentation

## sip_rseq_t

typedef struct sip_rseq_s sip_rseq_t

@

The RSeq header identifies provisional responses within a transaction. Its syntax is defined in RFC 3262 section 10 as follows:

RSeq = "RSeq" HCOLON response-num
response-num = 1*DIGIT
DIGIT
#define DIGIT

The parsed RSeq header is stored in sip_rseq_t structure.

The structure sip_rseq_t contains representation of an RSeq header.

The sip_rseq_t is defined as follows:

typedef struct sip_rseq_s
{
sip_common_t rs_common; // Common fragment info
sip_error_t *rs_next; // Dummy link to next
uint32_t rs_response; // Sequence number of response
} sip_rseq_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_rseq_s
Structure for RSeq header.
Definition sip.h:693
sip_rseq_s::rs_response
unsigned long rs_response
Sequence number of response.
Definition sip.h:696
sip_rseq_s::rs_common
sip_common_t rs_common[1]
Common fragment info.
Definition sip.h:694
sip_rseq_s::rs_next
sip_error_t * rs_next
Dummy link to next.
Definition sip.h:695
uint32_t
SU_U32_T uint32_t

## Function Documentation

## sip_is_rseq()

int sip_is_rseq | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_rseq_t.

Check if the header class is an instance of RSeq header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header rseq
  0 | (false) otherwise

## sip_rseq_copy()

sip_rseq_t * sip_rseq_copy | ( | su_home_t * | home,
|  | sip_rseq_t const * | hdr )

inline

Copy a list of RSeq header header structures sip_rseq_t.

The function sip_rseq_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  rseq = sip_rseq_copy(home, sip->sip_rseq);
  sip_rseq_copy
  sip_rseq_t * sip_rseq_copy(su_home_t *home, sip_rseq_t const *hdr))
  Copy a list of RSeq header header structures sip_rseq_t.
  Definition sip_protos.h:3134

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_rseq_dup()

sip_rseq_t * sip_rseq_dup | ( | su_home_t * | home,
|  | sip_rseq_t const * | hdr )

inline

Duplicate a list of RSeq header header structures sip_rseq_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  rseq = sip_rseq_dup(home, sip->sip_rseq);
  sip_rseq_dup
  sip_rseq_t * sip_rseq_dup(su_home_t *home, sip_rseq_t const *hdr))
  Duplicate a list of RSeq header header structures sip_rseq_t.
  Definition sip_protos.h:3091

Returns
  A pointer to the newly duplicated sip_rseq_t header structure, or NULL upon an error.

## sip_rseq_format()

sip_rseq_t * sip_rseq_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a RSeq header from formatting result.

Make a new sip_rseq_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_rseq_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_rseq_init()

sip_rseq_t * sip_rseq_init | ( | sip_rseq_t | x[1] | ) |

inline

Initialize a structure sip_rseq_t.

An sip_rseq_t structure for RSeq header can be initialized with the sip_rseq_init() function/macro. For instance,

sip_rseq_t sip_rseq;
sip_rseq_init(&sip_rseq);
sip_rseq_init
sip_rseq_t * sip_rseq_init(sip_rseq_t x[1])
Initialize a structure sip_rseq_t.
Definition sip_protos.h:3022

## sip_rseq_make()

sip_rseq_t * sip_rseq_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a RSeq header structure sip_rseq_t.

The function sip_rseq_make() makes a new sip_rseq_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_rseq_t header structure, or NULL upon an error.

## Variable Documentation

## sip_rseq_class

msg_hclass_t sip_rseq_class[]

extern

Header class for RSeq header.

The header class sip_rseq_class defines how a SIP RSeq header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_rseq_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.